$LOAD_PATH.unshift('/home/starosta/c3sl/dspace-scripts/dspace-rest-client/lib')
require 'dspace'

client = Dspace::Client.new(dspace_api: 'https://seppirdev.c3sl.ufpr.br:8443/rest',logger: Logger.new(STDOUT))
if !client.is_running?
  raise 'Can\'t connect to DSpace API.'
end

client.login 'admin@seppirdev.com', 'adminadmin'

puts "Deletando todas os elementos"
client.communities.all.each do |community|
  puts "-> #{community.name}"

  client.communities.collections(:id => community.id).each do |collection|
    puts "\t->#{collection.name}"

    client.collections.items(:id => collection.id, limit: 10, offset: 0, expand: "metadata").each do |item|
      puts "\t\t->#{item.name}"
      client.collections.items.delete(item)

      # client.items.bitstreams(:id => item.id).each do |bitstream|
        # puts "Deletando o bitstream: #{bitstream.name}"
        # client.items.bitstreams.delete(bitstream)
      # end
    end
  end
end
