class String
  def extractMeta
    self[/#{"\""}(.*?)#{"\""}/m, 1]
  end
end

class String
  def removeIndex
    self.partition(' ')[-1]
  end
end

def parseCollection searchColl
  $client.communities.all.each do |community|
    $client.communities.collections(:id => community.id).each do |collection|
      # p "procurado #{I18n.transliterate(searchColl).gsub('_',' ').removeIndex }"
      # p "achado #{I18n.transliterate(collection.name).gsub('_',' ')}"
      if((I18n.transliterate(searchColl).gsub('_',' ').removeIndex <=> I18n.transliterate(collection.name).gsub('_',' ').removeIndex) == 0)
        return(collection.id)
      end
    end
  end
  return(0)
end

def parseCommunity searchComm
  $client.communities.all.each do |community|
    if(I18n.transliterate(searchComm).removeIndex == I18n.transliterate(community.name).removeIndex)
        return(community.id)
    end
  end
  return(0)
end
def parseItem searchItem
  $client.communities.all.each do |community|
    $client.communities.collections(:id => community.id).each do |collection|
      $client.collections.items(:id => collection.id, limit: 10, offset: 0, expand: "metadata").each do |item|
        if(searchItem == item.name)
          return(item.id)
        end
      end
      return(0)
    end
  end
end
def getName meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 1)
      return(line.extractMeta)
    end
  i += 1
  }
end

def getDescription meta
  f = File.open(meta, "r")
  i = 0
  f.each_line{|line|
    if(i == 2)
      return(line.extractMeta)
    end
  i += 1
  }
end

def getItemMeta meta
  f = File.open(meta, "r")
  i = 0
  metaArray = Array.new
  f.each_line{|line|
    metaArray << line.extractMeta
  }
  return(metaArray)
end

def itemFinderRec file,id
  g = Dir[file + "/*"].sort
  g.each{|file|
    if(file.split('.')[-1] != "metadata")
      target = file
      fileName = target.split('/')[-1]
      target = fileName.split("_")
      if(target[0] == "NUCLEO")
        itemFinderRec(file,id)
      end

      if(target[0] == "COL")
        fileName = fileName[4..-1].gsub(' ',' ')
        id = parseCollection(fileName)
        if(id == 0)
          puts "file: #{fileName} ID zerado"
        end
        itemFinderRec(file,id)
      end

      if(target[0] == "ITEM")
        createItem(file,id)
      end
    end
  }
end

def createItem file,id
  meta = file + "/" + file.split('/')[-1] + ".metadata"
  if(File.exist?(meta))
  metarray = getItemMeta(meta)
  title = metarray[0]
  metarray.delete_at(0)
  author = metarray[0]
  metarray.delete_at(0)
  description = metarray[-1]
  metarray.delete_at(-1)
  keywords = metarray
  else
  $metamiss+= 1
  title = file.split('/')[-1].gsub('_',' ')
  author = ""
  description = ""
  keywords = title.split(' ')
  end
  item_metadata = Dspace::Item.new(
  'metadata' => [
    {'key' => "dc.title", 'value' => title},
    {'key' => "dc.creator", 'value' => author},
    {'key' => "dc.description", 'value' => description}
    ]
  )
  # p id
  if(id == 0)
    p "Item-miss #{title} file: #{file}"
    $itemmiss += 1
    $missedCols << file
  else
    p "Criando item #{title}"
    item = $client.collections.create_item(item_metadata, id: id)
  end

   g = Dir[file + "/*"].sort
   g.each{|file|
     if(file.split('.')[-1]=="pdf")
       itemFile = File.new(file,'r')
       p "\t\t\tCriando bitstream #{file.split('/')[-1]}"

       $client.items.add_bitstream(
       itemFile,
       id:item.id,
       name:file.split('/')[-1].gsub('_',' '),
       description:" "
       )
     end
   }
end
###################################################################################################
$LOAD_PATH.unshift('/home/starosta/c3sl/dspace-scripts/dspace-rest-client/lib')
#################################### A U T E N T I C A C A O ######################################
require 'dspace'
require "i18n"
I18n.available_locales = [:en]

if(ARGV[0] == "debug")
$client = Dspace::Client.new(dspace_api: 'https://seppirdev.c3sl.ufpr.br:8443/rest', logger: Logger.new(STDOUT))
else
  $client = Dspace::Client.new(dspace_api: 'https://seppirdev.c3sl.ufpr.br:8443/rest')
end

if !$client.is_running?
  raise 'Can\'t connect to DSpace API.'
end
$client.login 'admin@seppirdev.com', 'adminadmin'
#################################### C O L E C O E S ##############################################
$metamiss = 0
$itemmiss = 0
$missedCols = Array.new
root ='/home/starosta/c3sl/dspaceFiles/BANCO-SEPPIR-20160624/'
d = Dir[root + "*"].sort
d.each{|file|
  com = file
  nameFile = file.split("/")[-1]
  nameFile = nameFile[7..-1]
  nameFile = nameFile.gsub('_',' ')
  id = parseCommunity(nameFile)
  itemFinderRec(file,id)
}
puts"Item-Miss: #{$itemmiss} Misses: #{$metamiss}"
puts "Missed cols"
$missedCols.each{|col|
  p col
}
